#!/usr/bin/env python
import sys
sys.stdout = open("analyze.out", 'w')
sys.stderr = open("analyze.err", 'w')

import puq
import csv
import numpy as np
import os, h5py
from puq.jpickle import unpickle
import xml.etree.ElementTree as xml


def load_from_hdf5(name):
    h5 = h5py.File(name, 'r+')
    sw = unpickle(h5['private/sweep'].value)
    sw.fname = os.path.splitext(name)[0]
    h5.close()

    sw.psweep._sweep = sw

    if hasattr(sw.psweep, 'reinit'):
        sw.psweep.reinit()
    return sw

sw = load_from_hdf5(sys.argv[1])
sw.analyze()

h5 = h5py.File(sys.argv[1], 'r+')


dtree = xml.parse('run_uq.xml')
droot = dtree.getroot()
dout = droot.find('output')

uqtype = h5.attrs['UQtype']
for v in h5[uqtype]:
    print 'PDF', v
    rs = unpickle(h5['/%s/%s/response' % (uqtype, v)].value)
    pdf = rs.pdf(fit=False)

    id = '%s PDF' % v
    elem = xml.SubElement(dout, 'curve', {'id': id})
    about = xml.SubElement(elem, 'about')
    label = xml.SubElement(about, 'label')
    label.text = id
    desc = xml.SubElement(about, 'description')
    desc.text = "PDF for %s" % id
    yaxis = xml.SubElement(elem, 'yaxis')
    label = xml.SubElement(yaxis, 'label')
    label.text = 'Probability'

    component = xml.SubElement(elem, 'component')
    xy = xml.SubElement(component, 'xy')
    pts = "%s 0\n" % pdf.x[0]
    for x, y in zip(pdf.x, pdf.y):
        pts += "%s %s\n" % (x, y)
    pts += "%s 0\n" % pdf.x[-1]
    xy.text = pts

with open('run_uq.xml', 'w') as f:
    f.write("<?xml version=\"1.0\"?>\n")
    dtree.write(f)


h5.close()
